nopaque.app.endpoints.Users = class Users {
  constructor(app) {
    this.app = app;

    this.socket = io('/users', {transports: ['websocket'], upgrade: false});
  }

  async get(id) {
    const response = await this.socket.emitWithAck('get', id);

    if (response.status !== 200) {
      throw new Error(`[${response.status}] ${response.statusText}`);
    }

    return response.body;
  }

  async subscribe(id) {
    const response = await this.socket.emitWithAck('subscribe', id);

    if (response.status != 200) {
      throw new Error(`[${response.status}] ${response.statusText}`);
    }
  }

  async unsubscribe(id) {
    const response = await this.socket.emitWithAck('unsubscribe', id);

    if (response.status != 200) {
      throw new Error(`[${response.status}] ${response.statusText}`);
    }
  }

  async delete(id) {
    const response = await this.socket.emitWithAck('delete', id);

    if (response.status != 202) {
      throw new Error(`[${response.status}] ${response.statusText}`);
    }

    return response.body;
  }
}
